<?php
require_once('phprpc_server.php');

// url get method macro.
define('G_PR_GET_TYPE_FILE', 1); // use fopen() function
define('G_PR_GET_TYPE_SOCKET', 2); // use standard fsocketopen function
// main function to be called
function googlepr($url,$gettype=G_PR_GET_TYPE_FILE){
    $hashvalue = GPR_awesomeHash($url);
    $googlePRUrl = "http://toolbarqueries.google.com/search?client=navclient-auto&googleip=O;937&ie=UTF-8&oe=UTF-8&features=Rank&ch=$hashvalue&q=info:$url";
    $pr_str = retrieveURLContent($googlePRUrl,$gettype);
    return intval(substr($pr_str,strrpos($pr_str, ":")+1));
}
function zeroFill($a, $b) {
    $z = hexdec(80000000);
    if ($z & $a) {
        $a = ($a>>1);
        $a &= (~$z);
        $a |= 0x40000000;
        $a = ($a>>($b-1));
    } else {
        $a = ($a>>$b);
    }
    return $a;
}
 
function GPR_toHex8($intega){
    $Ziffer = "0123456789abcdef";
    return $Ziffer[($intega%256)/16].$Ziffer[$intega%16];
}
 
function GPR_hexEncodeU32($num) {
    $result = GPR_toHex8(zeroFill($num,24));
    $result .= GPR_toHex8(zeroFill($num,16) & 255);
    $result .= GPR_toHex8(zeroFill($num,8) & 255);
    return $result . GPR_toHex8($num & 255);
}
 
function GPR_awesomeHash($value) {
    $GPR_HASH_SEED = "Mining PageRank is AGAINST GOOGLE'S TERMS OF SERVICE. Yes, I'm talking to you, scammer.";
    $kindOfThingAnIdiotWouldHaveOnHisLuggage = 16909125;
    for($i = 0; $i < strlen($value); $i++ ) {
        $kindOfThingAnIdiotWouldHaveOnHisLuggage ^= ord(substr($GPR_HASH_SEED, $i % strlen($GPR_HASH_SEED),1)) ^ ord(substr($value, $i,1));
        $kindOfThingAnIdiotWouldHaveOnHisLuggage = zeroFill($kindOfThingAnIdiotWouldHaveOnHisLuggage,23) | $kindOfThingAnIdiotWouldHaveOnHisLuggage << 9;
    }
    return '8'.GPR_hexEncodeU32($kindOfThingAnIdiotWouldHaveOnHisLuggage);
}
 
// return url page content or false if failed.
function retrieveURLContent($url,$gettype){
    switch($gettype){
        case G_PR_GET_TYPE_FILE:
            return retrieveURLContentByFile($url);
            break;
        default:
            return retrieveURLContentBySocket($url);
            break;
    }
}
 
function retrieveURLContentByFile($url){
    $fd = @fopen($url,"r");
    if(!$fd){
        return false;
    }
    $result = "";
    while($buffer = fgets($fd, 4096)) {
        $result .= $buffer;
    }
    fclose($fd);
    return $result;
}
 
function retrieveURLContentBySocket($url,$host="",$port=80,$timeout=30){
    if($host == ""){
        if(!($pos = strpos($url,'://'))){
            return false;
        }
        $host = substr($url,$pos+3,strpos($url,'/',$pos+3) - $pos - 3);
        $uri = substr($url,strpos($url,'/',$pos+3));
    }else{
        $uri = $url;
    }
 
    $request = "GET ".$uri." HTTP/1.0rn"
           ."Host: ".$host."rn"
           ."Accept: */*rn"
           ."User-Agent: ZealGetrn"
           ."rn";
    $sHnd = @fsockopen ($host, $port, $errno, $errstr, $timeout);
    if(!$sHnd){
        return false;
    }
 
    @fputs ($sHnd, $request);
  
    // Get source
    $result = "";
    while (!feof($sHnd)){
        $result .= fgets($sHnd,4096);
    }
    fclose($sHnd);
  
    $headerend = strpos($result,"rnrn");
    if (is_bool($headerend)){
        return $result;
    }else{
        return substr($result,$headerend+4);
    }
}

$server = new PHPRPC_Server();
$server->add('googlepr');
$server->start();
?>